=== debian/changelog ===
liblo (0.31-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 0.31
  * Bump S-V to 4.5.0
  * Bump dh-compat to 13
  * Use https protocol for all urls
  * Add me as uploader
  * Drop obsolete name from d/upstream/metadata
  * Add Bug-Submit to d/upstream/metadata
  * d/copyright: Update year and http to https
  * Add doc-base file for liblo-dev

  [ Felipe Sateler ]
  * Remove unnecessary override of dh_missing.
    Since compat 13, --fail-missing is the default
  * Wrap long lines in changelog entries: 0.30-3.

 -- Felipe Sateler <fsateler@debian.org>  Thu, 21 May 2020 16:40:59 -0400
