=== debian/control ===
Source: liblo
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Felipe Sateler <fsateler@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-buildinfo,
               doxygen
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/multimedia-team/liblo
Vcs-Git: https://salsa.debian.org/multimedia-team/liblo.git
Homepage: https://github.com/radarsat1/liblo
Rules-Requires-Root: no

Package: liblo-dev
Architecture: any
Section: libdevel
Depends: liblo7 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: liblo0-dev
Provides: liblo0-dev
Replaces: liblo0-dev
Description: Lightweight OSC library -- development files
 LibLO is a lightweight, easy to use implementation of the OSC (Open
 Sound Control) protocol (see
 <https://www.cnmat.berkeley.edu/OpenSoundControl/> for details).
 .
 Open Sound Control (OSC) is a protocol for communication among
 computers, sound synthesizers, and other multimedia devices that is
 optimized for modern networking technology. OSC features:
 .
  * Open-ended, dynamic, URL-style symbolic naming scheme
  * Symbolic and high-resolution numeric argument data
  * Pattern matching language to specify multiple recipients of a
    single message
  * High resolution time tags
  * "Bundles" of messages whose effects must occur simultaneously
  * Query system to dynamically find out the capabilities of an OSC
    server and get documentation
 .
 This package contains headers, documentation and static libraries.

Package: liblo7
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: liblo-dev
Pre-Depends: ${misc:Pre-Depends}
Description: Lightweight OSC library
 LibLO is a lightweight, easy to use implementation of the OSC (Open
 Sound Control) protocol (see
 <https://www.cnmat.berkeley.edu/OpenSoundControl/> for details).
 .
 Open Sound Control (OSC) is a protocol for communication among
 computers, sound synthesizers, and other multimedia devices that is
 optimized for modern networking technology. OSC features:
 .
  * Open-ended, dynamic, URL-style symbolic naming scheme
  * Symbolic and high-resolution numeric argument data
  * Pattern matching language to specify multiple recipients of a
    single message
  * High resolution time tags
  * "Bundles" of messages whose effects must occur simultaneously
  * Query system to dynamically find out the capabilities of an OSC
    server and get documentation

Package: liblo-tools
Architecture: any
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Lightweight OSC library (command-line tools)
 LibLO is a lightweight, easy to use implementation of the OSC (Open
 Sound Control) protocol (see
 <https://www.cnmat.berkeley.edu/OpenSoundControl/> for details).
 .
 Open Sound Control (OSC) is a protocol for communication among
 computers, sound synthesizers, and other multimedia devices that is
 optimized for modern networking technology. OSC features:
 .
  * Open-ended, dynamic, URL-style symbolic naming scheme
  * Symbolic and high-resolution numeric argument data
  * Pattern matching language to specify multiple recipients of a
    single message
  * High resolution time tags
  * "Bundles" of messages whose effects must occur simultaneously
  * Query system to dynamically find out the capabilities of an OSC
    server and get documentation
 .
 This package contains the tools included with the library.
