## liblo 0.32

=== cmake/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 option(WITH_TOOLS "Enable building tools." ON)
 option(WITH_TESTS "Enable building tests." ON)
@@ -11,19 +11,27 @@
   message(STATUS "If you are using the static library build, please keep in mind (and inform yourself of the implications) that liblo is licensed with LGPL v2.1+.")
 endif()
 
+if(NOT CMAKE_BUILD_TYPE)
+    message(STATUS "Setting build type to 'Release' as none was specified.")
+    set(CMAKE_BUILD_TYPE "Release" CACHE STRING
+        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel")
+endif()
+
+set(PROJECT liblo)
+set(PACKAGE_NAME "${PROJECT}")
+if (WITH_CPP_TESTS)
+  project(${PROJECT} LANGUAGES C CXX)
+else()
+  project(${PROJECT} LANGUAGES C)
+endif()
+
+
 include(CheckIncludeFiles)
 include(CheckSymbolExists)
 include(CheckLibraryExists)
 include(TestBigEndian)
 include(GNUInstallDirs)
-
-set(PROJECT liblo)
-set(PACKAGE_NAME "${PROJECT}")
-if (WITH_CPP_TESTS)
-  project(${PROJECT} LANGUAGES C CXX)
-else()
-  project(${PROJECT} LANGUAGES C)
-endif()
+include(CMakePackageConfigHelpers)
 
 if(NOT CMAKE_VERSION VERSION_LESS 3.1.0)
     set_property(TARGET ${LIBRARY} PROPERTY C_STANDARD 11)
@@ -60,16 +68,18 @@
   endif()
 endif()
 
-set(LIBRARY_SHARED lo_shared)
+set(LIBRARY_SHARED liblo)
 if (WITH_STATIC)
-  set(LIBRARY_STATIC lo_static)
+  set(LIBRARY_STATIC liblo_static)
 endif()
 if (WITH_TOOLS)
   set(OSCDUMP oscdump)
   set(OSCSEND oscsend)
+  set(OSCSENDFILE oscsendfile)
 endif()
 if (WITH_TESTS)
   set(TESTLO testlo)
+  set(TESTTCP test_bidirectional_tcp)
   set(SUBTEST subtest)
   if (WITH_CPP_TESTS)
     set(CPPTEST cpp_test)
@@ -84,8 +94,8 @@
   set(NONBLOCKING_SERVER_EXAMPLE nonblocking_server_example)
 endif()
 
-set(TOOLS ${OSCDUMP} ${OSCSEND})
-set(TESTS ${TESTLO} ${SUBTEST})
+set(TOOLS ${OSCDUMP} ${OSCSEND} ${OSCSENDFILE})
+set(TESTS ${TESTLO} ${TESTTCP} ${SUBTEST})
 list(APPEND TESTS ${CPPTEST})
 set(EXAMPLES ${EXAMPLE_CLIENT} ${EXAMPLE_SERVER}
   ${EXAMPLE_TCP_ECHO_SERVER} ${NONBLOCKING_SERVER_EXAMPLE})
@@ -119,7 +129,9 @@
 
 set(OSCDUMP_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/tools/oscdump.c)
 set(OSCSEND_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/tools/oscsend.c)
+set(OSCSENDFILE_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/tools/oscsendfile.c)
 set(TESTLO_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/testlo.c)
+set(TESTTCP_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/test_bidirectional_tcp.c)
 set(SUBTEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/subtest.c)
 if (WITH_CPP_TESTS)
     set(CPPTEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../src/cpp_test.cpp)
@@ -148,7 +160,7 @@
   else()
     option(CMAKE_THREAD_PREFER_PTHREAD "Prefer pthread to other thread libraries." ON)
   endif()
-  include(FindThreads)
+  find_package(Threads)
   if (NOT Threads_FOUND)
     message(FATAL_ERROR "No supported thread library found.")
   endif()
@@ -163,8 +175,8 @@
 set(BUILD_LANGUAGE C CACHE STRING "Build language (C or CXX)")
 mark_as_advanced(BUILD_LANGUAGE)
 set_source_files_properties(
-    ${LIBRARY_SOURCES} ${OSCDUMP_SOURCES} ${OSCSEND_SOURCES}
-    ${TESTLO_SOURCES} ${EXAMPLE_CLIENT_SOURCES}
+    ${LIBRARY_SOURCES} ${OSCDUMP_SOURCES} ${OSCSEND_SOURCES} ${OSCSENDFILE_SOURCES}
+    ${TESTLO_SOURCES} ${TESTTCP_SOURCES} ${EXAMPLE_CLIENT_SOURCES}
     ${EXAMPLE_SERVER_SOURCES} ${EXAMPLE_TCP_ECHO_SERVER_SOURCES}
     ${NONBLOCKING_SERVER_EXAMPLE_SOURCES}
     PROPERTIES LANGUAGE ${BUILD_LANGUAGE})
@@ -184,15 +196,34 @@
 if (WITH_TOOLS)
   add_executable(${OSCDUMP} ${OSCDUMP_SOURCES})
   add_executable(${OSCSEND} ${OSCSEND_SOURCES})
+  add_executable(${OSCSENDFILE} ${OSCSENDFILE_SOURCES})
 endif()
 
 # Tests
 if (WITH_TESTS)
   add_executable(${TESTLO} ${TESTLO_SOURCES})
   add_executable(${SUBTEST} ${SUBTEST_SOURCES})
+  add_executable(${TESTTCP} ${TESTTCP_SOURCES})
+  target_link_libraries(${TESTLO} PRIVATE Threads::Threads)
+  target_link_libraries(${TESTTCP} PRIVATE Threads::Threads)
+  if (WIN32)
+    # If you use the new syntax, on Windows, you need to run `cmake -C Release` instead of `cmake`.
+    # We do not want that, so we use the old syntax for Windows...
+    add_test(${TESTLO} "tests/${TESTLO}")
+    add_test("test-bidirectional-tcp" "tests/${TESTTCP}")
+  else()
+    add_test(NAME ${TESTLO} COMMAND ${TESTLO} WORKING_DIRECTORY $<TARGET_FILE_DIR:${TESTLO}>)
+    add_test(NAME "test-bidirectional-tcp" COMMAND ${TESTTCP} WORKING_DIRECTORY $<TARGET_FILE_DIR:${TESTTCP}>)
+  endif()
+  enable_testing()
 endif()
 if (WITH_CPP_TESTS)
   add_executable(${CPPTEST} ${CPPTEST_SOURCES})
+  if (WIN32)
+    add_test(${CPPTEST} "tests/${CPPTEST}")
+  else()
+    add_test(NAME ${CPPTEST} COMMAND ${CPPTEST} WORKING_DIRECTORY $<TARGET_FILE_DIR:${CPPTEST}>)
+  endif()
 endif()
 
 # Examples
@@ -206,9 +237,9 @@
 if(THREADING)
     set(ENABLE_THREADS 1)
 
-    target_link_libraries(${LIBRARY_SHARED} Threads::Threads)
+    target_link_libraries(${LIBRARY_SHARED} PRIVATE Threads::Threads)
     if (WITH_STATIC)
-      target_link_libraries(${LIBRARY_STATIC} Threads::Threads)
+      target_link_libraries(${LIBRARY_STATIC} PRIVATE Threads::Threads)
     endif()
 
     set(THREADS_INCLUDE
@@ -219,13 +250,19 @@
 endif()
 
 if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
-    target_link_libraries(${LIBRARY_SHARED} "user32" "wsock32" "ws2_32" "iphlpapi")
-    if(THREADING AND Threads_FOUND)
-      target_link_libraries(${LIBRARY_SHARED} ${CMAKE_THREAD_LIBS_INIT})
-      if (WITH_STATIC)
-        target_link_libraries(${LIBRARY_STATIC} ${CMAKE_THREAD_LIBS_INIT})
-      endif()
-    endif()
+	target_link_libraries(${LIBRARY_SHARED} PRIVATE "wsock32" "ws2_32" "iphlpapi")
+  if (WITH_STATIC)
+	  target_link_libraries(${LIBRARY_STATIC} PRIVATE "wsock32" "ws2_32" "iphlpapi")
+  endif()
+  if (WITH_EXAMPLES)
+	target_link_libraries(${NONBLOCKING_SERVER_EXAMPLE} PRIVATE "wsock32")
+  endif()
+  if (WITH_TESTS)
+	target_link_libraries(${TESTLO} PRIVATE "wsock32")
+  endif()
+  if (WITH_CPP_TESTS)
+	target_link_libraries(${TESTTCP} PRIVATE "wsock32")
+  endif()
 
     set_target_properties(${LIBRARY_SHARED} PROPERTIES
         COMPILE_DEFINITIONS "LIBLO_DLL")
@@ -241,31 +278,43 @@
         set(DEFTHREADS ";;")
     endif()
 else()
-  target_link_libraries(${LIBRARY_SHARED} "m")
+  target_link_libraries(${LIBRARY_SHARED} PRIVATE "m")
   if (WITH_STATIC)
-    target_link_libraries(${LIBRARY_STATIC} "m")
-  endif()
-endif()
-
-set(LO_INCLUDE_DIRS
+    target_link_libraries(${LIBRARY_STATIC} PRIVATE "m")
+  endif()
+endif()
+
+set(LO_BUILD_INCLUDE_DIRS
     ${CMAKE_CURRENT_BINARY_DIR}
     ${CMAKE_CURRENT_SOURCE_DIR}/..)
-target_include_directories(${LIBRARY_SHARED} PUBLIC ${LO_INCLUDE_DIRS})
+target_include_directories(${LIBRARY_SHARED} PUBLIC
+    "$<BUILD_INTERFACE:${LO_BUILD_INCLUDE_DIRS}>"
+    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
 if (WITH_STATIC)
-  target_include_directories(${LIBRARY_STATIC} PUBLIC ${LO_INCLUDE_DIRS})
+    target_include_directories(${LIBRARY_STATIC} PUBLIC
+        "$<BUILD_INTERFACE:${LO_BUILD_INCLUDE_DIRS}>"
+        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
 endif()
 
 foreach(PROG ${PROGRAMS})
-  target_include_directories(${PROG} PUBLIC ${LO_INCLUDE_DIRS})
-  target_link_libraries(${PROG} PUBLIC ${LIBRARY_SHARED})
+    target_include_directories(${PROG} PUBLIC
+        "$<BUILD_INTERFACE:${LO_BUILD_INCLUDE_DIRS}>"
+        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
+  if(CMAKE_SYSTEM_NAME MATCHES "Windows")
+    # For some yet unknown reasons, Windows has trouble finding the DLL
+    target_link_libraries(${PROG} PUBLIC ${LIBRARY_STATIC})
+  else()
+    target_link_libraries(${PROG} PUBLIC ${LIBRARY_SHARED})
+  endif()
 endforeach(PROG)
 
 foreach(PROG ${TOOLS})
-  set_property(TARGET ${PROG} PROPERTY RUNTIME_OUTPUT_DIRECTORY "tools")
+    set_property(TARGET ${PROG} PROPERTY RUNTIME_OUTPUT_DIRECTORY
+        "tools")
 endforeach(PROG)
 
 foreach(PROG ${TESTS})
-  set_property(TARGET ${PROG} PROPERTY RUNTIME_OUTPUT_DIRECTORY "tests")
+    set_property(TARGET ${PROG} PROPERTY RUNTIME_OUTPUT_DIRECTORY "tests")
 endforeach(PROG)
 
 foreach(PROG ${EXAMPLES})
@@ -291,61 +340,3 @@
 file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/../configure.ac"
     CONFIGURE_AC_LINE REGEX "m4_define\\(\\[lt_revision\\], [0-9]+\\)")
 string(REGEX MATCHALL "[0-9]+" CONFIGURE_AC_LIST ${CONFIGURE_AC_LINE})
-list(GET CONFIGURE_AC_LIST 1 CONFIGURE_AC_REVISION)
-file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/../configure.ac"
-    CONFIGURE_AC_LINE REGEX "m4_define\\(\\[lt_age\\], [0-9]+\\)")
-string(REGEX MATCHALL "[0-9]+" CONFIGURE_AC_LIST ${CONFIGURE_AC_LINE})
-list(GET CONFIGURE_AC_LIST 1 CONFIGURE_AC_AGE)
-set(LO_SO_VERSION
-    "{${CONFIGURE_AC_CURRENT}, ${CONFIGURE_AC_REVISION}, ${CONFIGURE_AC_AGE}}")
-
-math(EXPR CURRENT_MINUS_AGE "${CONFIGURE_AC_CURRENT} - ${CONFIGURE_AC_AGE}")
-set_target_properties(${LIBRARY_SHARED} PROPERTIES
-    VERSION   "${CURRENT_MINUS_AGE}.${CONFIGURE_AC_AGE}.${CONFIGURE_AC_REVISION}"
-    SOVERSION "${CURRENT_MINUS_AGE}"
-    OUTPUT_NAME "lo"
-    )
-if (WITH_STATIC)
-  set_target_properties(${LIBRARY_STATIC} PROPERTIES
-      OUTPUT_NAME "lo"
-      )
-endif()
-
-if(NOT DEFINED PRINTF_LL)
-    message(STATUS "Check how to print long long int")
-    try_compile(PRINTF_LL_AVAILABLE ${CMAKE_CURRENT_BINARY_DIR}
-        SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/test-printf-ll.c")
-    if(PRINTF_LL_AVAILABLE)
-        set(PRINTF_LL "ll" CACHE INTERNAL "")
-    else()
-        try_compile(PRINTF_LL_AVAILABLE ${CMAKE_CURRENT_BINARY_DIR}
-            SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/test-printf-I64.c")
-        if(PRINTF_LL_AVAILABLE)
-            set(PRINTF_LL "I64" CACHE INTERNAL "")
-        else()
-            message(FATAL_ERROR "printf doesn't support long long int")
-        endif()
-    endif()
-endif()
-
-if(MSVC)
-    set(VERSION "${CONFIGURE_AC_CURRENT}.${CONFIGURE_AC_REVISION}")
-    configure_file(
-        ${CMAKE_CURRENT_SOURCE_DIR}/config-msvc.h.in
-        ${CMAKE_CURRENT_BINARY_DIR}/config.h)
-    configure_file(
-        ${CMAKE_CURRENT_SOURCE_DIR}/../src/liblo.def.in
-        ${CMAKE_CURRENT_BINARY_DIR}/src/liblo.def)
-    if (WITH_STATIC)
-      set_target_properties(${LIBRARY_STATIC} PROPERTIES
-          LINK_FLAGS "/DEF:\"${CMAKE_CURRENT_BINARY_DIR}/src/liblo.def\"")
-    endif()
-    set_target_properties(${LIBRARY_SHARED} PROPERTIES
-        LINK_FLAGS "/DEF:\"${CMAKE_CURRENT_BINARY_DIR}/src/liblo.def\"")
-else()
-    configure_file(
-        ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
-        ${CMAKE_CURRENT_BINARY_DIR}/config.h)
-endif()
-
-configure_file(
