=== debian/changelog ===
liblo (0.32-2) unstable; urgency=medium

  [ наб ]
  * Remove dh-buildinfo (Closes: #1090774)

  [ Sebastian Ramacher ]
  * debian/control:
    - Bump Standards-Version
    - Remove old Provides+Conflicts+Replaces liblo0-dev

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 29 Dec 2024 19:16:02 +0100

liblo (0.32-1) unstable; urgency=medium

  [ Felipe Sateler ]
  * Remove myself from uploaders

  [ Dennis Braun ]
  * New upstream version 0.32
  * Bump Standards-Version to 4.6.2
  * Update d/liblo7.symbols with new functions
  * d/watch: Use github API to download from releases page
  * Change my email address

 -- Dennis Braun <snd@debian.org>  Sun, 28 Apr 2024 17:59:12 +0200
