=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: liblo
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
- Felipe Sateler <fsateler@debian.org>,
- Dennis Braun <d_braun@kabelmail.de>
+ Dennis Braun <snd@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-buildinfo,
                doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/multimedia-team/liblo
 Vcs-Git: https://salsa.debian.org/multimedia-team/liblo.git
 Homepage: https://github.com/radarsat1/liblo
@@ -19,9 +17,6 @@
 Section: libdevel
 Depends: liblo7 (= ${binary:Version}),
          ${misc:Depends}
-Conflicts: liblo0-dev
-Provides: liblo0-dev
-Replaces: liblo0-dev
 Description: Lightweight OSC library -- development files
  LibLO is a lightweight, easy to use implementation of the OSC (Open
  Sound Control) protocol (see
