=== debian/rules ===
--- 
+++ 
@@ -7,17 +7,9 @@
 
 .PHONY: build
 %:
-	dh $@ --with buildinfo
+	dh $@
 
 build: build-arch
-
-override_dh_autoreconf:
-	test -e README || ln -v README.md README
-	dh_autoreconf
-
-override_dh_autoreconf_clean:
-	rm -f README
-	dh_autoreconf_clean
 
 override_dh_auto_configure:
 	test "$(DEB_HOST_ARCH_CPU)" != "sparc"
