## liblo 0.34

=== cmake/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 option(WITH_CPP_TESTS "Enable building C++ wrapper tests." ON)
 option(WITH_STATIC "Enable building static library." OFF)
 option(THREADING "Build with threading support." ON)
+option(WITH_POLL "Build with poll support." ON)
 
 if (WITH_STATIC)
   message(STATUS "If you are using the static library build, please keep in mind (and inform yourself of the implications) that liblo is licensed with LGPL v2.1+.")
@@ -141,7 +142,12 @@
 set(EXAMPLE_TCP_ECHO_SERVER_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../examples/example_tcp_echo_server.c)
 set(NONBLOCKING_SERVER_EXAMPLE_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../examples/nonblocking_server_example.c)
 
-check_symbol_exists(poll poll.h HAVE_POLL)
+if (WITH_POLL)
+    check_symbol_exists(poll poll.h HAVE_POLL)
+else()
+    message(STATUS "Excluding poll support.")
+    set(HAVE_POLL OFF)
+endif()
 check_symbol_exists(select sys/select.h HAVE_SELECT)
 if(NOT HAVE_POLL AND NOT HAVE_SELECT)
   if(CMAKE_SYSTEM_NAME MATCHES "Windows")
@@ -338,5 +344,3 @@
 string(REGEX MATCHALL "[0-9]+" CONFIGURE_AC_LIST ${CONFIGURE_AC_LINE})
 list(GET CONFIGURE_AC_LIST 1 CONFIGURE_AC_CURRENT)
 file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/../configure.ac"
-    CONFIGURE_AC_LINE REGEX "m4_define\\(\\[lt_revision\\], [0-9]+\\)")
-string(REGEX MATCHALL "[0-9]+" CONFIGURE_AC_LIST ${CONFIGURE_AC_LINE})
