=== debian/changelog ===
liblo (0.34-1) unstable; urgency=medium

  * New upstream version 0.34
  * Refresh d/liblo7.symbols file

 -- Dennis Braun <snd@debian.org>  Sun, 09 Nov 2025 22:47:45 +0100

liblo (0.32-3) unstable; urgency=medium

  * Team Upload
  * Remove obsolete debian/README.source
  * Remove 'Rules-Requires-Root: no': it's the default now

 -- Alexandre Detiste <tchet@debian.org>  Sun, 17 Aug 2025 20:13:21 +0200
