=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://api.github.com/repos/radarsat1/liblo/releases?per_page=100 \
 https://github.com/radarsat1/liblo/releases/download/[\d.]+/liblo-@ANY_VERSION@@ARCHIVE_EXT@
